/**
 * オブジェクト指向を使用しないジャンケンプログラム
 * 教科書2章にあるものとほぼ同じ
 */
public class SimapleJanken {
	// page 29
	/** ジャンケンの手を表す定数 グー */
	public static final int STONE = 0;
	/** ジャンケンの手を表す定数 チョキ */
	public static final int SCISSORS = 1;
	/** ジャンケンの手を表す定数 パー */
	public static final int PAPER = 2;
	
	/**
	 * プログラムのスタート部分
	 * 全てmainメソッドに処理がはいってます！
	 */
	public static void main(String[] args)
	{
		// プレイヤー１の勝ち数
		int player1WinCount = 0;
		
		// プレイヤー２の勝ち数
		int player2WinCount = 0;

		// プレイヤー１が出す手
		int player1Hand = 0;
		
		// プレイヤー２が出す手
		int player2Hand = 0;

		// ジャンケンの手を決めるのに使用する乱数
		double randomNum = 0;

		// (1) プログラム開始メッセージを表示する
		// page 29 
		System.out.println("Start Janken (chapter 2a)\n");

		// ジャンケンを３回実施する
		// 　(6) 勝負した回数を加算する
		// 　(7) ３回勝負が終わったか？
		// page 34
		for (int cnt = 0; cnt < 3; cnt++) {
			// 何回戦目かを表示する
			System.out.println("Game " + (cnt + 1));

			// 　(2) プレイヤー１が何を出すか決める
			// 0.0以上3.0未満の小数として乱数を得る
			randomNum = Math.random() * 3;

			if (randomNum < 1)
			{
				// randomNum が 0.0以上1.0未満 の場合、グー
				player1Hand = STONE;

				// プレイヤー１の手を表示する
				System.out.print("STONE");
			}
			else if (randomNum < 2)
			{
				// randomNum が 1.0以上2.0未満 の場合、チョキ
				player1Hand = SCISSORS;

				// プレイヤー１の手を表示する
				System.out.print("SCISSORS");
			}
			else if (randomNum < 3)
			{
				// randomNum が 2.0以上3.0未満 の場合、パー
				player1Hand = PAPER;

				// プレイヤー１の手を表示する
				System.out.print("PAPER");
			}

			System.out.print(" vs. ");

			// 　(3) プレイヤー２が何を出すか決める
			// page 31

			// 0.0以上3.0未満の小数として乱数を得る
			randomNum = Math.random() * 3;

			if (randomNum < 1)
			{
				// randomNum が 0.0以上1.0未満 の場合、グー
				player2Hand = STONE;

				// プレイヤー２の手を表示する
				System.out.print("STONE");
			}
			else if (randomNum < 2)
			{
				// randomNum が 1.0以上2.0未満 の場合、チョキ
				player2Hand = SCISSORS;

				// プレイヤー２の手を表示する
				System.out.print("SCISSORS");
			}
			else if (randomNum < 3)
			{
				// randomNum が 2.0以上3.0未満 の場合、パー
				player2Hand = PAPER;

				// プレイヤー３の手を表示する
				System.out.print("PAPER");
			}

			// 　(4) どちらが勝ちかを判定し、結果を表示する
			// page 33

			// プレイヤー１が勝つ場合
			if ((player1Hand == STONE && player2Hand == SCISSORS)
					|| (player1Hand == SCISSORS && player2Hand == PAPER)
					|| (player1Hand == PAPER && player2Hand == STONE))
			{
				// ジャンケンの結果を表示する
				System.out.println("\nPlayer1 is winner!\n");

				// 　(5)プレイヤー１の勝った回数を加算する
				// p.33-34
				player1WinCount++;
			}
			// プレイヤー２が勝つ場合
			else if ((player1Hand == STONE && player2Hand == PAPER)
					|| (player1Hand == SCISSORS && player2Hand == STONE)
					|| (player1Hand == PAPER && player2Hand == SCISSORS))
			{
				// ジャンケンの結果を表示する
				System.out.println("\nPlayer2 is winner!\n");

				// 　(5) プレイヤー２の勝った回数を加算する
				// page 33
				player2WinCount++;
			}
			// 引き分けの場合
			else
			{
				// ジャンケンの結果を表示する
				System.out.println("\ndraw!\n");
			}
		}

		// 　(8) 最終的な勝者を判定し、画面に表示する
		// page 35
		System.out.println("Game over.\n");

		// プレイヤー１の勝ち数が多い時
		if (player1WinCount > player2WinCount)
		{
			// プレイヤー１の勝ちを表示する。
			System.out.println(player1WinCount + " vs " + player2WinCount
					+ ", Player1 is winner!\n");
		}
		// プレイヤー２の勝ち数が多い時
		else if (player1WinCount < player2WinCount)
		{
			// プレイヤー２の勝ちを表示する。
			System.out.println(player1WinCount + " vs " + player2WinCount
					+ ", Player2 is winner!\n");
		}
		// プレイヤー１と２の勝ち数が同じ時
		else if (player1WinCount == player2WinCount)
		{
			// 引き分けを表示する。
			System.out.println(player1WinCount + " vs " + player2WinCount
					+ ", a draw game.\n");
		}
	}

}
