﻿/**
 * 簡単な数値計算を含むクラス． オブジェクト指向としては最悪． とはいえ機能はします．
 * 
 * @author kaiya
 */
public class SimpleMath {

	/**
	 * 二つの非負整数の最小公倍数を計算．
	 * 
	 * @param x
	 *            整数1
	 * @param y
	 *            整数2
	 * @return 双方が非負整数なら最小公倍数を計算し，そうでなければ-1をかえす．
	 */
	public static int gcd(int x, int y) {
		if (x > 0 && y > 0) {
			while (true) {
				if (x == y)
					return x;
				if (x < y) { // swap
					int z;
					z = x;
					x = y;
					y = z;
				}
				x = x - y;
			}
		} else { // cannot calculate
			return -1;
		}
	}

	/**
	 * 整数根の計算
	 * 
	 * @param r
	 * @return rがゼロ以上なら√rより小さい整数の最大のものを返し，そうでなければ-1を返す
	 */
	public static int iroot(int r) {
		int n = 0, m = 0;
		if (r < 0)
			return -1; // cannot handle.
		while (true) {
			if (m + (2 * (n + 1) - 1) > r)
				return n;
			n++;
			m = m + 2 * n - 1;
		}
	}

	/**
	 * 実行テストです
	 */
	public static void main(String[] args) {
		System.out.println(gcd(12, 9));

		System.out.println(iroot(16));
		System.out.println(iroot(24));
		System.out.println(iroot(25));
	}
}
